
    '-------------------------------------------------------------------------------
    'This program is an update of the original program called
    '--- Installer program v2.0. The program was original created
    'by Gordon Rahman. You can find it in lb newsletter 111.
    'Create a token of this file after you adjust any settings.
    'Copy the token file into same folder as your program files.
    'You will also need to have a copy of the LB runtime
    'renamed to the same name as this token in order to run
    'the installer. A recommended name for the installer is
    'setup or install so your user will easily know what
    'to click in order to install your software. If you distribute your
    'program in a zip file, Winzip will know what to do when your user
    'clicks the setup. This can help out users who are new to software
    'installing. Feel free to make any suggestions or report any bugs.
    '
    '--------------------------------------------------------------------------------

    'Credits:release 7/12/07
    'Thanks to Alyce Brad and Laz for their help and code. - From Gordon Rahman.
    'Ben Jimenez ben_jimenez@yahoo.com
    'Updates-
    'Progress Bar
    'Updated Graphics
    'Shortcut Creation
    'New file copy routine
    '
    'important notes
    'The file list below is the install required files
    'when destributing your program. These files will
    'not be installed onto a users computer.
    'in most cases try not to change the names of the files
    'unless your sure of what to do.
    'XXMKLINK.EXE   -program that creates shortcuts
    'background.bmp -Default background file
    'inshield.bmp   -Install window graphic
    'progress.bmp   -Progress bar graphic
    '-----new Variables----------------------------
    'dShortcut$ - Desktop shortcut file name
    'pShortcut$ - Programs shortcut file name
    'eTarget$   - Your program exe file name, do not add full path, just file name
    'dFolder$   - This is the folder that your program will be installed into
                 'It will be created if it does not exists.
    'programs   - 1 if we want to create a shortcut on the programs menu
    'desktop    - 1 if we want to create a shortcut on the desktop
    '----constants--------------
    'CSIDLDESKTOPDIRECTORY =hexdec( "&H10")  'get desktop path
    'CSIDLPROGRAMS = hexdec("&H2")                'get programs menu path
    'CSIDLPROGRAMFILES =hexdec("&H26")   'get program files path


    nomainwin

    '-------------------------------------------------------------------------
    'setup default values

    dim Finfo$(10,3)
    dim FileTree$(2000)
    MaxEntries = 1999

    c$ = chr$(13)
    e$ ="*.*"

    CSIDLDESKTOPDIRECTORY =hexdec( "&H10")  'user desktop
    CSIDLPROGRAMS = hexdec("&H2")                'Start Menu\Programs
    CSIDLPROGRAMFILES =hexdec("&H26")   'Program files
    'setup up shortcut information
    dShortcut$="My Program.lnk" 'set this to your desktop shortcut name
    pShortcut$="My Program.lnk" 'set this to your programs listing name
    eTarget$="myprogram.exe" 'set this to your program executable, do not include the path.
                             ' the exe file must exists in order to create the short cut correctly
    dFolder$="Myprogram"  'set your programs folder to be created, do not use full path.

    'load back ground graphics
    loadbmp "bluescreen","background.bmp"'new
    loadbmp "welcomewindow","inshield.bmp"'new

    'user defined
    iName$="Sample Install" 'this is the main window title
    iWelcome$="Sample Welcome"'this is the first install window title
    'first window info
    iWelcomeText$= "This is the beginning of the install for ";iName$ +c$+_
    " on this computer." +c$+c$+_
    "This setup program will install the"+c$+_
    "files and programs to the "+c$+_
    "destination directory."+c$+c$+_
    "The following shortcuts will be "+c$+_
    "Created. Uncheck any you do "+_
    "not want."

    '2nd window info
    iInstallInfo$="Setup will install the programs in the following directory."+c$+c$+_
    "To install to this directory, click Next."+c$+c$+_
    "To install to a different directory, click Browse and select"+c$+_
    "another directory"+c$+c$+_
    "You can choose not to install the programs by clicking"+c$+_
    "Cancel to exit Setup"
    '3rd window install
      iStart$="Setup has enough information to start copying the files."+c$+_
    "If you want to review or change any settings, click <Back."+c$+c$+_
    "If you are satisfied with the settings,"+c$+_
    "click Next> to begin copying files."
    'canel window info
    iCancel$="Setup is not complete. If you quit now"+c$+_
    "the program will not be installed."+c$+c$+_
    "You may run the Setup at a later time."+c$+c$+_
    "To continue installing the program click Resume"+c$+_
    "Click Exit Setup to leave the Setup"


'--------open background window
    open iName$ for graphics_fs_nsb as #main 'full screen window and no scrollbar
    'add background
    #main,"background bluescreen"
    #main,"drawsprites"
    #main,"getbmp bg 0 0 1500 1500"
    #main,"drawbmp bg 0 0;flush"

    print #main, "trapclose [quit]"              'test the close window button
    print #main, "font ms_sans_serif 0 16"


'-----------------

[firstwindow]
    '----------open first setup window---------------
    WindowWidth = 450
    WindowHeight = 360
    UpperLeftX=int((DisplayWidth-WindowWidth)/2)
    UpperLeftY=int((DisplayHeight-WindowHeight)/2)
    groupbox #1.i,"", 155, 17, 270, 262         'allocate space (buttonface)
    button #1.c,"Next>", [next1], UL, 380, 297, 48, 25
    button #1.d,"Cancel", [cancel1], UL, 305, 297, 54, 25
    graphicbox #1.a, 20, 20, 122, 258           'allocate space for inshield bitmap

    statictext #1.j,"", 175, 40, 240, 220       'for some introtext (welcome)
                                                'allocate space for the introtext
    checkbox #1.check1,"Desktop Shortcut",[check1check],[check1uncheck],175,180,150,20 'new
    checkbox #1.check2,"Programs Shortcut",[check2check],[check2uncheck],175,200,150,20'new

    open iWelcome$ for dialog_modal as #1

    window1 = 1

    print #1.a,"down;drawbmp welcomewindow 0 0; flush"   'draw bmp on screen at graphicbox

    print #1,"trapclose [cancel1]"              'test the close window button
    print #1.c,"!setfocus"                      'emphasize the Next> button
    print #1, "font ms_sans_serif 0 9"          'font for coming text
    print #1.j, iWelcomeText$                            'put text on screen in class j
    #1.check1,"set" 'new
    #1.check2,"set" 'new

                                            'wait for action
wait

'new---------------------------------
[check1check]
dekstop=1
wait
[check1uncheck]
desktop=0
wait
[check2check]
programs=1
wait
[check2uncheck]
programs=0
wait
'-----------------------------




[next1]
  '------add shortcuts
  #1.check1, "value? result1$"
  if result1$="set" then
    desktop=1


  end if

  #1.check2,"value? result2$"
  if result2$="set" then
  programs=1


  end if
    if window1 = 1 then close #1 : window1 =0 : goto [secondwindow]

    '------------------------------------------------

[secondwindow]
     '-------------open destination window------------------------------


    WindowWidth = 450
    WindowHeight = 360
    UpperLeftX=int((DisplayWidth-WindowWidth)/2)'new
    UpperLeftY=int((DisplayHeight-WindowHeight)/2)'new
    button #2.b, "<Back", [back2], UL, 275, 297, 50, 25 'UL is upper left anchor
    button #2.c, "Next>", [next2], UL, 355, 297, 50, 25 '355 and 297 X-Y position
    button #2.d, "Cancel", [cancel1], UL, 200, 297, 54,25 '54 and 25 button size
    button #2.e, "Browse...", [browse2], UL, 355, 242, 71, 25
    graphicbox #2.a, 20, 20, 122, 258
    statictext #2.i, "", 162, 20, 288, 180
    groupbox #2.j,"Destination Directory", 155, 222, 275,60
    textbox #2.k, 172, 240,175,30

    open "Choose destination location" for dialog_modal as #2
    window2 = 1

    print #2.a,"down;drawbmp welcomewindow 0 0; flush"'new
    print #2.c,"!setfocus"
    print #2, "trapclose [back2]"



    print #2.i, iInstallInfo$

    print #2.k,"!font times 9"'changed

    '---get default program files path
   'new
    DestinationPath$=GetSpecialfolder$(CSIDLPROGRAMFILES)+"\"+dFolder$

    print #2.k, DestinationPath$

    sPath$=DestinationPath$
    wait

[back2]
    if window2 = 1 then close #2 : window2 =0 : goto [firstwindow]
[next2]
    print #2.k,"!contents? DestinationPath$"
    if DestinationPath$ ="" then wait
    if window2 = 1 then close #2 : window2 =0 : goto [thirdwindow]
[browse2]
    goto [browsewindow]
    wait
'-------------------------------------------------------------
[thirdwindow]                                   'here we will start the copy
    '----------------open confirm window-------------------------
    WindowWidth = 450
    WindowHeight = 360
    UpperLeftX=int((DisplayWidth-WindowWidth)/2)'new
    UpperLeftY=int((DisplayHeight-WindowHeight)/2)'new
    button #3.b, "<Back", [back3], UL, 275, 297  'size of button is an option
    button #3.c, "Next>", [next3], UL, 355, 297  'and not strictly needed
    button #3.d, "Cancel", [cancel1], UL,200,297
    graphicbox #3.a, 20,20,122,258
    groupbox #3.m, "",162,105,275,180
    statictext #3.i, "",162,20, 288,70
    statictext #3.j,"",172,115,260,60
    statictext #3.k, "",172,220,260,60

    open "Start Copying Files" for dialog_modal as #3
    window3 = 1

    print #3.a,"down;drawbmp welcomewindow 0 0; flush"'new
    print #3.c,"!setfocus"
    print #3, "trapclose [cancel1]"



    l$="Source Directory"+c$+c$+DefaultDir$

    print #3.i, iStart$
    print #3.j,"!font times 9"'changed
    print #3.j, l$
    print #3.k,"!font times 9"'changed
    print #3.k, "Destination Directory"+c$+c$+DestinationPath$
    wait

[back3]
    if window3 = 1 then close #3 : window3 =0 : goto [secondwindow]
[next3]
    if window3 = 1 then close #3 : window3 =0 : goto [finale]

[cancel1]

    WindowWidth = 300
    WindowHeight = 200
    UpperLeftX=int((DisplayWidth-WindowWidth)/2)'new
    UpperLeftY=int((DisplayHeight-WindowHeight)/2)'new
    button #canc.e, "Resume", [resume], UL, 215, 137, 64, 25
    button #canc.f, "Exit Setup", [quit], UL, 125, 137, 76, 25
    statictext #canc.g, "", 22, 22, 260, 100

    open "Exit Setup" for dialog_modal as #canc
    window4 = 1
    print #canc, "trapclose [quit]"



    print #canc.g, iCancel$
    wait

[resume]
    close #canc
    wait



[finale]'begin the install progress----------------------------------------
WindowWidth=220
WindowHeight=100

UpperLeftX=int((DisplayWidth-WindowWidth)/2)'new
UpperLeftY=int((DisplayHeight-WindowHeight)/2)'new

button #install.button1,"Cancel",[finishclick], UL,80,40,50,  25 'new
graphicbox #install.graphicbox1,5,10,200,20'new

loadbmp "pro","progress.bmp"'new

open "Installing...." for dialog_modal as #install'new

#install,"trapclose [finishclick]";'new


   'CREATE DESTINATION PATH

   'this routine has been changed from original
    result = mkdir(DestinationPath$)


       sPath$ = DefaultDir$ + "\"

       Entries = FileTree(MaxEntries, 0, 0, sPath$, 24, 1, 1, 1)

       'new px
       px=200/Entries'adjust progress indicator progress value
                     'Max of 200 files

           'ERROR CHECK AND FIX DESTINATION PATH
            if right$(DestinationPath$,1)<>"\" then
                DestinationPath$=DestinationPath$+"\"
            end if

       If Entries > 0 Then
            For x = 0 to Entries
            fName$ = FileTree$(x)


            cursor hourglass
            'GET FILE TO BE COPIED NAME
            for xx=len(fName$) to 1 step -1
                if mid$(fName$,xx,1)="\" then
                tName$=right$(fName$,len(fName$)-xx)
                exit for
            end if
            next xx

            'do not copy install files
            SELECT CASE tName$
                case "XXMKLINK.EXE"
                tName$=""
                case "background.bmp"
                tName$=""
                case "inshield.bmp"
                tName$=""
                case "progress.bmp"
                tName$=""
            END SELECT


            'COPY FILE TO DESTINATION PATH
             res=copyfile(fName$,DestinationPath$+tName$)'new
            #install.graphicbox1,"drawbmp pro ";pp;" 0 "'new
            #install.graphicbox1,"flush"'new
            pp=pp+px 'move bitmap to show progress --new
            Next x
            cursor normal
       End If
        'create desktop shortcut if selected
    if desktop=1 then
        GetSpecialfolder$=GetSpecialfolder$(CSIDLDESKTOPDIRECTORY)
        if GetSpecialfolder$<>"" AND GetSpecialfolder$<>"Error" then

        run "xxmklink.exe /q "+chr$(34)+GetSpecialfolder$+"\"+dShortcut$+CHR$(34)+" "+CHR$(34)+DestinationPath$+eTarget$+CHR$(34)+" "+chr$(34)+chr$(34)+" "+CHR$(34)+DestinationPath$,hide

        end if
    end if
    ' create programs shortcut if selected.
    if programs=1 then
        GetSpecialfolder$=GetSpecialfolder$(CSIDLPROGRAMS)
        if GetSpecialfolder$<>"" AND GetSpecialfolder$<>"Error" then

        run "xxmklink.exe /q "+CHR$(34)+GetSpecialfolder$+"\"+pShortcut$+CHR$(34)+" "+CHR$(34)+DestinationPath$+eTarget$+CHR$(34)+" "+chr$(34)+chr$(34)+" "+CHR$(34)+DestinationPath$,hide
        end if
    end if

   timer 1500,[finishinstall]'short pause to allow for creation of shortcuts

   wait
 [finishinstall]
    timer 0
      #install.button1,"Finished"

    wait

[finishclick]'new
unloadbmp "pro"
close #install
close #main
end

wait
'-----------------------------------------------------------------------------------
'--------------------------------------------------------------


[quit]                               'this will end the program
    if window4 = 1 then close #canc  'first close the cancel window
    if window1 = 1 then close #1     'close all remaining windows
    if window2 = 1 then close #2
    if window3 = 1 then close #3
    close #main                      'even close the main window
    end
'---------------------------------------------------------------
[browsewindow]'shows windows drive and folder list
 'to get browse window for folders create struct for api call

'hParent=hwnd(#windowhandle)
'call moveWindow hParent,WindowWidth,WindowHeight,UpperLeftX,UpperLeftY


    STRUCT BrowseInfo,_
    hWndOwner As Long,_
    pIDLRoot As Long,_
    pszDisplayName As Long,_
    lpszTitle$ As ptr,_
    ulFlags As Long,_
    lpfnCallback As Long,_
    lParam As Long,_
    iImage As Long

    'Set the owner window, optional
    BrowseInfo.hWndOwner.struct = 0

    'set up text to display on the dialog:
    txt1$="Please select a DESTINATION folder!"

    'fill the struct item with the text
    BrowseInfo.lpszTitle$.struct = txt1$

    'Return only if the user selected a directory
    BrowseInfo.ulFlags.struct = 1

    'Show the 'Browse for folder' dialog
    calldll #shell32, "SHBrowseForFolder",_
        BrowseInfo as struct,_
        lpIDList as long

    'return > 0 = success, so continue
    If lpIDList>0 Then
        'set up a string buffer:
       DestinationPath$ = space$(260) + chr$(0)
        'Get the path from the IDList
        calldll #shell32, "SHGetPathFromIDList",_
            lpIDList as long,_
            DestinationPath$ as ptr,_
            r as long

        'the folder name is now in sPath$

        open "ole32" for dll as #ole
        'free the block of memory
        calldll #ole, "CoTaskMemFree",_
            lpIDList as long,_
            r as long
        close #ole

        'check for null char, which
        'signals end of folder name string
        iNull = InStr(DestinationPath$, chr$(0))

        'truncate string at null character
        If iNull Then
            DestinationPath$ = Left$(DestinationPath$, iNull - 1)
        End If
    End If

    'if user cancelled, sPath$ is empty
    if DestinationPath$="" then wait 'DestinationPath$= "loadname"

    print #2.k, DestinationPath$

wait
[quitbrow]
    close #brow
    wait
'------------------------------------------------------------------------


'-----------------functions--------------------------------------------------------
' Recursive function by Brad

Function FileTree(MaxEntries,CurrentEntry,CurrentLevel,sPath$,txLen,Tree,Subdirs,SortKey)
'FileTree(MaxEntries, 0, 0, sPath$, 24, 1, 1, 1)
    If txLen = 0 Then txLen = 15
    If sPath$ = "" or MaxEntries = 0 Then
       FileTree$(1) = "Error - Path is blank, or MaxEntries = 0: Can't continue"
       CurrentEntry = 1
    Else

       If CurrentEntry + 1 < MaxEntries Then
          Files sPath$, "*.*", Finfo$()
          qtyFiles = Val(Finfo$(0, 0))
          qtySubDirs = Val(Finfo$(0, 1))

          'Now we will process the files on this level (of recursion)
          If qtyFiles > 0 Then

            For x =  qtyFiles to 1 step -1
               FileTree$(CurrentEntry) = sPath$ + Finfo$(x,0)
               'Insure there is room for the next entry
               CurrentEntry = CurrentEntry + 1
               If CurrentEntry >= MaxEntries Then Exit For
            Next x

         End If

         'Recurse any subdirectories if there are any and if Tree flag is set to one.
         If qtySubDirs > 0 and Tree = 1 Then
                x = 1
[FileTree.Loop]
                Files sPath$, "*.*", Finfo$()
                qtyFiles = Val(Finfo$(0, 0))
                qtySubDirs = Val(Finfo$(0, 1))

                If Right$(sPath$,1) <> "\" Then sPath$ = sPath$ + "\"
                NewPath$ = sPath$ + Finfo$(x+qtyFiles,1) + "\"

               'call FileTree recursively
                CurrentEntry = FileTree(MaxEntries, CurrentEntry, _
                                        CurrentLevel+1, NewPath$, txLen, Tree, Subdirs, SortKey)
               'increment our counter that tracks which endicy we are on...
                x = x + 1
            If x <= qtySubDirs AND CurrentEntry+1 < MaxEntries Then GoTo [FileTree.Loop]
         End If
      End If
   End If

   FileTree = CurrentEntry

End Function


'new
function copyfile(ExistingFileName$,NewFileName$)

calldll #kernel32,"CopyFileA",_
  ExistingFileName$ as ptr,_
  NewFileName$ as ptr,_
  result as boolean
  copyfile=result
end function

Function GetSpecialfolder$(CSIDL)
    'this function created by Alyce Watson

    struct IDL,cb As Long, abID As short

    'Get the special folder
    calldll #shell32, "SHGetSpecialFolderLocation",_
        0 as long, CSIDL as long, IDL as struct,_
        ret as long

    if ret=0 then
        'Create a buffer
        Path$ = Space$(512)+chr$(0)
        'Get the path from the IDList
        id=IDL.cb.struct

        calldll #shell32, "SHGetPathFromIDListA",_
        id as long, Path$ as ptr, ret as long

        'Remove the null chars
        GetSpecialfolder$ = Left$(Path$, InStr(Path$, Chr$(0)) - 1)
    else
        GetSpecialfolder$ = "Error"
    end if
End Function


'-------------------------------------------------------------------------------------------


